﻿###############################################################################
#                   Delete Distribution Group for Office 365                  #
#                             For Primary Group                               #
#                                  V3.9.8.9                                   #
#                       (C)2006-2022 KoXo Developpement                       #
###############################################################################
.("%LAUNCHING_PATH%\AdminScripts\KoXo-Tools.ps1")
.("%LAUNCHING_PATH%\AdminScripts\KoXo-ExchangeOnline.ps1")
###############################################################################
#                                    Main                                     #
###############################################################################
$Copyright = "(C)2006-2022 KoXo Developpement"
$Version = "V3.9.8.9"
$Title = "Delete distribution group for Office 365 $($Version)", "$($Copyright)"
# Office 365 params
$Office365LoginName = "%OFFICE365_ADMIN%"
$Office365LoginPassword = [System.Text.Encoding]::ASCII.GetString([System.Convert]::FromBase64String("%OFFICE365_BASE64_PASSWORD%"))
# Proxy parameters
$ProxyEnabled = $#BOOL{%PROXY_ENABLED%}
$ProxyUser = "%PROXY_USER%"     
$ProxyPassword = [System.Text.Encoding]::ASCII.GetString([System.Convert]::FromBase64String("%PROXY_BASE64_PASSWORD%"))
$ProxyUrl = "%PROXY_ADDRESS%"
$ProxyPort = %PROXY_PORT%
# Log filename
$LogFile = $MyInvocation.MyCommand.Definition 
$LogFile = $LogFile -replace(".ps1",".log")
#
$global:total_errors_count = 0
#
banner $Title
check_version
if (import_modules ExchangeOnlineManagement) {
    set_proxy $ProxyEnabled $ProxyUrl $ProxyPort $ProxyUser $ProxyPassword
    if ((connect_exo $Office365LoginName $Office365LoginPassword) -eq $true) {
        ### BEGIN_REPETITION ###
        $global:errors_count = 0
        # KoXo Administrator's variables
        $DistributionGroupName = "%SECONDARY_GROUP%"
        $DistributionGroupDisplayName = "%SECONDARY_GROUP_DESC%"
        $DistributionGroupAlias = "#LOWER{#REMOVE_SPACE{%SECONDARY_GROUP%}}"
        $DistributionGroupEmail = "%SECONDARY_GROUP_EMAIL%"
        #
        log_message "INFO" "Distribution group for secondary group : Name=""$($DistributionGroupName)"", DisplayName=""$($DistributionGroupDisplayName)"", Email=""$($DistributionGroupEmail)"", Alias=""$($DistributionGroupAlias)"""
        if (distribution_group_exists($DistributionGroupEmail)) {
            $S = "Distribution group, Name=""$($DistributionGroupName)"", DisplayName=""$($DistributionGroupDisplayName)"", Email=""$($DistributionGroupEmail)"", Alias=""$($DistributionGroupAlias)"""
            write-host $S
            delete_distribution_group $DistributionGroupName $DistributionGroupDisplayName $DistributionGroupAlias $DistributionGroupEmail
        }
        else {
            $global:errors_count++
            $S = "Distribution group, Name=""$($DistributionGroupName)"", DisplayName=""$($DistributionGroupDisplayName)"", Email=""$($DistributionGroupEmail)"", Alias=""$($DistributionGroupAlias)"" does not exists"
            write-host $S -foregroundcolor "red"
            log_message "ERROR" $S
        }
        log_errors_count $DistributionGroupName
        $global:total_errors_count = $global:total_errors_count + $global:errors_count
        ### END_REPETITION ###  
        Disconnect-ExchangeOnline -Confirm:$false		
    }
    else {
        $global:total_errors_count++
        $S = "Unable to connect to Exchange Online !"
        Write-Host $S -Foregroundcolor "Red"
        Log_Message "ERROR" $S
    }
}
else {
    $global:total_errors_count++
    $S = "ExchangeOnlineManagement Powershell module cannot be loaded !"
    Write-Host $S -Foregroundcolor "Red"
    Log_Message "ERROR" $S
}   
log_total_errors_count