﻿###############################################################################
#                     Create/Modify a user for Office 365                     #
#                                  V3.9.8.9                                   #
#                       (C)2006-2022 KoXo Developpement                       #
###############################################################################
.("%LAUNCHING_PATH%\AdminScripts\KoXo-Tools.ps1")
.("%LAUNCHING_PATH%\AdminScripts\KoXo-MSol.ps1")
.("%LAUNCHING_PATH%\AdminScripts\KoXo-ExchangeOnline.ps1")
###############################################################################
function exec {
    Param($UserEmail,
        $UserPassword, $UserMustChangePassword, $UserHiddenFromAddressLists,
        $UserDisplayName, $UserFunction, $UserFirstName, $UserLastName, $UserInitials,
        $UserPhone, $UserMobilePhone, $UserFaxNumber, $UserWebPage, $UserDepartment, $UserOffice, $UserCompany,
        $UserEmail1, $UserEmail2, $UserEmail3, $UserEmail4, $UserEmail5,
        $UserNotes,
        $UserPicture,
        $MemberOf,
        $CustomAttribute1, $CustomAttribute2, $CustomAttribute3,
        $CustomAttribute4, $CustomAttribute5, $CustomAttribute6,
        $CustomAttribute7, $CustomAttribute8, $CustomAttribute9,
        $CustomAttribute10, $CustomAttribute11, $CustomAttribute12,
        $CustomAttribute13, $CustomAttribute14, $CustomAttribute15
    )
    $UserDisplayName = $UserDisplayName.Trim()
    log_message "OFFICE365" "$($UserDisplayName) ($($UserEmail))"
    display_user $UserDisplayName $UserEmail
    if (user_exists($UserEmail)) {
        modify_user $UserEmail $UserMustChangePassword $UserHiddenFromAddressLists $UserDisplayName $UserFunction $UserFirstName $UserLastName $UserInitials $UserPhone $UserMobilePhone $UserFaxNumber $UserWebPage $UserDepartment $UserOffice $UserCompany $UserEmail1 $UserEmail2 $UserEmail3 $UserEmail4 $UserEmail5 $UserNotes $UserPicture $MemberOf $CustomAttribute1 $CustomAttribute2 $CustomAttribute3 $CustomAttribute4 $CustomAttribute5 $CustomAttribute6 $CustomAttribute7 $CustomAttribute8 $CustomAttribute9 $CustomAttribute10 $CustomAttribute11 $CustomAttribute12 $CustomAttribute13 $CustomAttribute14 $CustomAttribute15 
    }
    else {
        create_user $UserEmail $UserPassword $UserMustChangePassword $UserHiddenFromAddressLists $UserDisplayName $UserFunction $UserFirstName $UserLastName $UserInitials $UserPhone $UserMobilePhone $UserFaxNumber $UserWebPage $UserDepartment $UserOffice $UserCompany $UserEmail1 $UserEmail2 $UserEmail3 $UserEmail4 $UserEmail5 $UserNotes $UserPicture $MemberOf $CustomAttribute1 $CustomAttribute2  $CustomAttribute3 $CustomAttribute4 $CustomAttribute5 $CustomAttribute6 $CustomAttribute7 $CustomAttribute8 $CustomAttribute9 $CustomAttribute10 $CustomAttribute11 $CustomAttribute12 $CustomAttribute13 $CustomAttribute14 $CustomAttribute15
    }
    log_errors_count($UserEmail)   
    $global:total_errors_count = $global:total_errors_count + $global:errors_count
}
###############################################################################
#                                    Main                                     #
###############################################################################
$Copyright = "(C)2006-2022 KoXo Developpement"
$Version = "V3.9.8.9"
$Title = "Create/Modify user for Office 365 $($Version)", "$($Copyright)"
# Office 365 params
$Office365LoginName = "%OFFICE365_ADMIN%"
$Office365LoginPassword = [System.Text.Encoding]::ASCII.GetString([System.Convert]::FromBase64String("%OFFICE365_BASE64_PASSWORD%"))
# Proxy parameters
$ProxyEnabled = $#BOOL{%PROXY_ENABLED%}
$ProxyUser = "%PROXY_USER%"     
$ProxyPassword = [System.Text.Encoding]::ASCII.GetString([System.Convert]::FromBase64String("%PROXY_BASE64_PASSWORD%"))
$ProxyUrl = "%PROXY_ADDRESS%"
$ProxyPort = %PROXY_PORT%
# Log filename
$LogFile = $MyInvocation.MyCommand.Definition 
$LogFile = $LogFile -replace (".ps1", ".log")
#
$global:total_errors_count = 0
#
$DoNotUseUserPhones = $#BOOL{%OFFICE365_DO_NOT_USE_USER_PHONES%}
banner $Title
check_version
if (import_modules "MSOnline,ExchangeOnlineManagement") {
    set_proxy $ProxyEnabled $ProxyUrl $ProxyPort $ProxyUser $ProxyPassword
    if ((connect_msol $Office365LoginName $Office365LoginPassword) -eq $true) {
        if ((connect_exo $Office365LoginName $Office365LoginPassword) -eq $true) {
            ### BEGIN_REPETITION ###
            $global:errors_count = 0
            $UserMustChangePassword = $#BOOL{%OFFICE365_RESET_PASSWORD_ON_NEXT_LOGON%}
            $UserHiddenFromAddressLists = $#BOOL{%OFFICE365_USER_HIDDEN_FROM_ADDRESS_LISTS%}
            $UserEmail = "%USER_EMAIL%"
            $UserPassword = [System.Text.Encoding]::ASCII.GetString([System.Convert]::FromBase64String("%USER_BASE64_PASSWORD%"))
            $UserDisplayName = "%USER_DISPLAY_NAME%"
            $UserFunction = "%USER_FUNCTION%"
            $UserFirstName = "%USER_FIRST_NAME%"
            $UserLastName = "%USER_LAST_NAME%"
            $UserInitials = "%USER_INITIALS%"
            if ($DoNotUseUserPhones) { 
                $UserPhone = ""
                $UserMobilePhone = ""
                $UserFaxNumber = ""
            }
            else {
                $UserPhone = "%USER_PHONE%"
                $UserMobilePhone = "%USER_MOBILE_PHONE%"
                $UserFaxNumber = "%USER_FAX_NUMBER%"
            }
            $UserWebPage = "%USER_WEB_PAGE%"
            $UserDepartment = "%PRIMARY_GROUP% / %SECONDARY_GROUP%"
            $UserOffice = "%SECONDARY_GROUP%"
            $UserCompany = "%COMPANY%"
            $UserEmail1 = "%USER_EMAILS[1]%"
            $UserEmail2 = "%USER_EMAILS[2]%"
            $UserEmail3 = "%USER_EMAILS[3]%"
            $UserEmail4 = "%USER_EMAILS[4]%"
            $UserEmail5 = "%USER_EMAILS[5]%"
            $UserNotes = "%USER_REMARKS%"
            $UserPicture = "%USER_ID_THUMBNAIL_PICTURE%"
            $CustomAttribute1 = "#LOWER{#REMOVE_SPACE{%PRIMARY_GROUP%}}"
            $CustomAttribute2 = "#LOWER{#REMOVE_SPACE{%SECONDARY_GROUP%}}"
            $CustomAttribute3 = "%USER_UNIQUE_ID%"
            $CustomAttribute4 = "%USER_BIRTHDATE%"
            $CustomAttribute5 = "%USER_OTHER_MAILBOXES%"
            $CustomAttribute6 = ""
            $CustomAttribute7 = ""
            $CustomAttribute8 = ""
            $CustomAttribute9 = ""
            $CustomAttribute10 = ""
            $CustomAttribute11 = ""
            $CustomAttribute12 = ""
            $CustomAttribute13 = ""
            $CustomAttribute14 = ""
            $CustomAttribute15 = ""
            $MemberOf = "%PRIMARY_GROUP_EMAIL%,%SECONDARY_GROUP_EMAIL%"
            exec $UserEmail $UserPassword $UserMustChangePassword $UserHiddenFromAddressLists $UserDisplayName $UserFunction $UserFirstName $UserLastName $UserInitials $UserPhone $UserMobilePhone $UserFaxNumber $UserWebPage $UserDepartment $UserOffice $UserCompany $UserEmail1 $UserEmail2 $UserEmail3 $UserEmail4 $UserEmail5 $UserNotes $UserPicture $MemberOf $CustomAttribute1 $CustomAttribute2  $CustomAttribute3 $CustomAttribute4 $CustomAttribute5 $CustomAttribute6 $CustomAttribute7 $CustomAttribute8 $CustomAttribute9 $CustomAttribute10 $CustomAttribute11 $CustomAttribute12 $CustomAttribute13 $CustomAttribute14 $CustomAttribute15
            ### END_REPETITION ###
            Disconnect-ExchangeOnline -Confirm:$false
        }
        else {
            $global:total_errors_count++
            $S = "Unable to connect to Exchange Online !"
            Write-Host $S -Foregroundcolor "Red"
            Log_Message "ERROR" $S
        }
    }
    else {
        $global:total_errors_count++
        $S = "Unable to connect to MSonline !"
        Write-Host $S -Foregroundcolor "Red"
        Log_Message "ERROR" $S        
    }
}
else {
    $global:total_errors_count++
    $S = "ExchangeOnlineManagement Powershell module cannot be loaded !"
    Write-Host $S -Foregroundcolor "Red"
    Log_Message "ERROR" $S
}
log_total_errors_count